//+-----------------------------------------------------------+
//|                               EURUSD Negative Breakout EA |
//|                                               version 0.2 |
//|                               Original idea from mushy999 |
//|                                    EA conversion by Azmel |
//|                                 Copyright  Forex-TSD.com |
//+-----------------------------------------------------------+
//| INSTRUCTIONS: Attach the EA to EURUSD M5 chart.           |
//+-----------------------------------------------------------+
//| VERSION HISTORY                                           |
//| 0.1   - Initial release.                                  |
//| 0.2   - Trade short/long, opposite breakout signal is stop|
//|         loss for currently open position.Opens only one   |
//|         poisiotn in breakout direction.                   |
//+-----------------------------------------------------------+
#include <stdlib.mqh>

//EXTERNAL VARIABLES
extern int    Magic=327697;
extern double Lots=0.01;
extern int    TakeProfit=80;
extern int    StopLoss=1000;
extern int    HighCount=65;
extern int    FirstMAP=50;
extern int    SecondMAP=166;
extern int    FirstMAType0to4=2;          // Smoothed = 2
extern int    SecondMAType0to4=2;         // Smoothed = 2
extern int    FirstPriceType0to6=3;       // Low = 3
extern int    SecondPriceType0to6=0;      // Close = 0
extern int    ThirdPriceType0to6=2;      // High = 2
//extern int    PeriodsTillClose=310000;

int    counter;
//int    counter2=0;
double Low100;
double High100;
int    i;
int    slippage=5;
double FirstMA;
double SecondMA;
double ThirdMA;
double Price[2];

int init()
{
   return(0);
}
int start()
{
   int   numorders = CountTrades();
//   int iOrders=OrdersTotal()-1;
//   counter2++;
   FirstMA=iMA(Symbol(),0,FirstMAP,1,FirstMAType0to4,FirstPriceType0to6,1);
   SecondMA=iMA(Symbol(),0,SecondMAP,1,SecondMAType0to4,SecondPriceType0to6,1);
   ThirdMA=iMA(Symbol(),0,FirstMAP,1,FirstMAType0to4,ThirdPriceType0to6,1);
/*   
   if(counter2 > PeriodsTillClose)
   {
     for(i=iOrders; i>=0; i--) 
     {
       if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && (OrderType()<=OP_SELL) && GetMarketInfo() && !OrderClose(OrderTicket(),OrderLots(),Price[1-OrderType()],slippage)) Print(OrderError());
     }
     counter2=0;
   }
*/   
   
   High100=0;
   Low100=999;

   for(i=1;i<=HighCount;i++)
   {
      High100=MathMax(High100,High[i]);
      Low100=MathMin(Low100,Low[i]);
   }
   Comment("High ", High100, " Low ", Low100);

      if(Ask>High100+1*Point && FirstMA < SecondMA)
      {
        if(numorders > 0 && OrderType() == OP_SELL)
        {
            if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippage))
            {
               Print(OrderError());
            }
        }
        if( numorders == 0)
           if(!OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"GBPUSD Breakout",Magic,0,Blue))
               Print(OrderError());
      }
      else
      if(Bid<Low100-1*Point && ThirdMA > SecondMA)
      {
        if(numorders > 0 && OrderType() == OP_BUY)
        {
            if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippage))
            {
               Print(OrderError());
            }
        }     
        if( numorders == 0)
           if(!OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"GBPUSD Breakout",Magic,0,Red))
               Print(OrderError());
      }


   return(0);
}

int CountTrades()
{
   counter=0;
   for(i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==Magic)
      {
         counter++;
      }
   }
   return(counter);
}


//+------------------------------------------------------------------+
//| Function..: OrderError                                           |
//+------------------------------------------------------------------+
string OrderError() {
  int iError=GetLastError();
  return(StringConcatenate("Order:",OrderTicket()," GetLastError()=",iError," ",ErrorDescription(iError)));
}
 
/*
//+------------------------------------------------------------------+
//| Function..: GetMarketInfo                                        |
//| Returns...: bool Success.                                        |
//+------------------------------------------------------------------+
bool GetMarketInfo() {
  RefreshRates();
  Price[0]=MarketInfo(OrderSymbol(),MODE_ASK);
  Price[1]=MarketInfo(OrderSymbol(),MODE_BID);
  double dPoint=MarketInfo(OrderSymbol(),MODE_POINT);
  if(dPoint==0) return(false);
  //giSlippage=(Price[0]-Price[1])/dPoint;
  return(Price[0]>0.0 && Price[1]>0.0);
}
*/

